<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<link rel="alternate"
      type="application/rss+xml"
      href="https://blog.winny.tech/rss.xml"
      title="RSS feed for https://blog.winny.tech/"/>
<title>blog.winny.tech</title>

<link href="static/style.css?v=1.13" rel="stylesheet" type="text/css" />
<meta name="viewport" content="width=device-width, initial-scale=1">
</head>
<body>
<div id="preamble" class="status">
<nav>
<div class="flexcontainer">
<div class="smallitem">
<ul class="inline-list">
<li><a href=".">blog.winny.tech</a></li>
<li><a href="https://winny.tech/">About</a></li>
</ul>
</div>
<div class="bigitem">
<ul class="inline-list">
<li><a href="archive.html">Archive</a></li>
<li><a href="tags.html">Tags</a></li>
<li><a href="rss.xml">RSS Feed</a></li>
</ul>
</div>
</div>
</nav>
<hr/>
</div>
<div id="content">
<h1 class="title">Posts tagged "community":</h1>
<div class="post-date">23 Nov 2019</div><h1 class="post-title"><a href="2019-11-23-milwaukee-code-camp.html">Milwaukee Code Camp</a></h1>
<p>
This most recent weekend (November 16th) I attended the <a href="https://www.milwaukeecodecamp.com/">Milwaukee Code
Camp</a> and was pleased with the content. There was plenty of food,
coffee, and give-aways.
</p>

<div id="outline-container-org7265f93" class="outline-2">
<h2 id="org7265f93">The Talks</h2>
<div class="outline-text-2" id="text-org7265f93">
<p>
I attended five talks:
</p>

<ol class="org-ol">
<li>starting an open source project (<a href="https://www.milwaukeecodecamp.com/session/details/1217">link</a>) <sup><a id="fnr.1" class="footref" href="#fn.1">1</a></sup>,</li>
<li>how to manage work life balance as a software developer (<a href="https://www.milwaukeecodecamp.com/session/details/1210">link</a>),</li>
<li>getting started with <a href="https://docs.docker.com/engine/docker-overview/">Docker</a> and <a href="https://kubernetes.io">Kubernetes</a><sup><a id="fnr.2" class="footref" href="#fn.2">2</a></sup> (<a href="https://www.milwaukeecodecamp.com/session/details/1212">link</a>),</li>
<li>introduction to <a href="https://www.terraform.io/">Terraform</a> for cloud infrastructure management (<a href="https://www.milwaukeecodecamp.com/Session/Details/1205">link</a>),</li>
<li>and accessibility (a11y) on the modern web (<a href="https://www.milwaukeecodecamp.com/session/details/1234">link</a>).</li>
</ol>

<p>
I am pleased to say the open source fellow recommended GPLv3, MIT/X,
and Apache 2.0 (and <a href="https://choosealicense.com/">choosealicense.com</a>), so I have a lot of respect
for him. I think a lesser open source evangelist would recommend one
license, or strongly recommend one license. It really does depend on
your project.
</p>

<p>
I was able to get <a href="https://github.com/kubernetes/minikube">Minikube</a> set up during the Docker/k8s talk in five
minutes. No surprises when installing it from the official Gentoo
repository. Just follow the installed readme, run the commands… it's
really quite easy to do. A friend commented it wasn't so simple on
their system to install Minikube and get it working.
</p>

<p>
While I don't think I would use Terraform at this point, I have a
good appreciation for when I might use it in the future. In
addition, I found a <a href="https://github.com/dmacvicar/terraform-provider-libvirt">Terraform provider for libvirt</a>, so one could in
theory provision their own cloud infrastructure on a simple libvirt
cluster with Terraform. I believe this might be my first use-case
for Terraform.
</p>

<p>
It was refreshing to see people talking about accessibility and the
web. I am personally not a fan of the web stack for various
reasons.<sup><a id="fnr.3" class="footref" href="#fn.3">3</a></sup> But the reality is the technology won't go away, and the
browser is the greatest common denominator both reaching users and
simplifying the a project's platform support matrix. It was great to
hear from somebody in industry "your website should be <b>somewhat</b>
usable without javascript". I am really pleased to hear this; perhaps
there is hope for the web ecosystem yet.
</p>
</div>
</div>

<div id="outline-container-orgc412795" class="outline-2">
<h2 id="orgc412795">The Food</h2>
<div class="outline-text-2" id="text-orgc412795">
<p>
Sweet pastries, water, soda, coffee were available in the
morning ad throughout the day. There may have been more
comprehensive breakfast items (cereal?), though I was late for the
first session. Lunch was Dominos pizza and brownies. There was no
shortage of pizza. The coffee was catered from Panera Bread.
</p>
</div>
</div>

<div id="outline-container-org8e6e150" class="outline-2">
<h2 id="org8e6e150">Conclusion</h2>
<div class="outline-text-2" id="text-org8e6e150">
<p>
In addition to learning about Terraform, Kubernetes, and
accessibility, I met a lot of cool people. I think this event was an
overwhelming success. Thanks to everybody who organized this event.
</p>
</div>
</div>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" class="footnum" href="#fnr.1">1</a></sup> <div class="footpara"><p class="footpara">
Slides <a href="https://github.com/NickSchweitzer/Presentations">here</a>.
</p></div></div>

<div class="footdef"><sup><a id="fn.2" class="footnum" href="#fnr.2">2</a></sup> <div class="footpara"><p class="footpara">
See the example Docker-ized and Kubernetes-ized application on
BitBucket <a href="https://bitbucket.org/Bolbeck/mkecodecampnodemysql/src/master/">here</a>.
</p></div></div>

<div class="footdef"><sup><a id="fn.3" class="footnum" href="#fnr.3">3</a></sup> <div class="footpara"><p class="footpara">
This is a discussion in itself. For example: I think a large
majority of the user and developer experience with web technologies
does not adhere to the <a href="https://en.wikipedia.org/wiki/Principle_of_least_astonishment">principle of least surprise</a>, making it very
frustrating for everyone involved.
</p></div></div>


</div>
</div><div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-community.html">community</a> </div>
<div class="post-date">18 Nov 2019</div><h1 class="post-title"><a href="2019-11-18-won-msoe-x-google-cloud-hackathon.html">Won MSOE x Google Cloud Hackathon</a></h1>
<p>
About a fortnight ago (Nov 9th) I went to the MSOE x Google Cloud
hackathon.<sup><a id="fnr.1" class="footref" href="#fn.1">1</a></sup> There was pizza, soda, and Google Cloud gear. Each group
was given a <a href="https://aiyprojects.withgoogle.com/vision">Google AIY Computer Vision kit</a> to assemble, and build a
proof of concept around.
</p>

<p>
The kit contained a <a href="https://www.adafruit.com/product/3400">Raspberry Pi Zero W</a>, the <a href="https://www.adafruit.com/product/3099">Raspberry Pi Camera
Add-on</a>, a breakout board to provide simplified pin-outs for a button
with an integrated light, an additional LED that mounted next to the
camera to indicate if the camera was active, and a piezo buzzer.<sup><a id="fnr.2" class="footref" href="#fn.2">2</a></sup> All
these components fit into a carefully engineered cardboard box that
folded onto itself, held together with adhesive tape. The assembled
device was remarkably robust and easy to operate.
</p>

<div id="outline-container-org0f8a453" class="outline-2">
<h2 id="org0f8a453">Challenges</h2>
<div class="outline-text-2" id="text-org0f8a453">
<p>
We were among the first group to finish building the kit. It turned
out the software on the included SD card was not exactly what we
needed, and the SD card writing software for Windows (<a href="https://etcher.io/">Etcher</a>) was a
bit unreliable and did not clearly indicate to the user of a
successful write. After a second attempt we had bootable SD card.
</p>

<p>
The system took a couple minutes to boot and resize itself. Mind
you, we did not have a Mini-HDMI to HDMI cable, nor a monitor to
output the Raspberry Pi display. Thus we had to wait, chat, and eat
pizza.
</p>

<p>
The next challenge was to &ldquo;pair&rdquo; the device with a wifi network so
one could SSH into it. There is an android app for this, and at
first we paired it with a spare android device acting as a
hotspot. Unfortunately this configuration did not give us internet
access when connected to this wireless access point. We were able to
verify the device was working, SSH in, and inspect the images we
took via the kit&rsquo;s included camera.
</p>

<p>
We moved to a more central location, as the most cognitively
demanding part was complete &#x2014; construction of the device, and
ensuring it works. This lead to more networking challenge. We wanted
a way to network this device to the internet so we could not only
log into it via SSH, but access PyPi from the device, and access
StackOverflow from our laptops on the same network. With a little
brainstroming we came up with this network topology:
</p>


<figure>
<img src="static/image/msoe-network-topology.png" alt="msoe-network-topology.png">

</figure>

<p>
Yes, as you can see the path from the internet is (A) public wifi
(B) my friend Karl&rsquo;s android phone (C) his laptop via bluetooth
tethering (D) finally a wifi network via his laptop&rsquo;s built in
wifi. We had an intemittent hiccup with nameserver configuration not
set up correctly on the host wifi network — as such any DNS would
not resolve. A quick tweak to Karl&rsquo;s network manager settings
mitigated this. And like that… we were networked together on a
private wifi network complete with internet access.
</p>

<p>
There were some other techincal issues. Because of our network
topology, the round trip time to the internet was very high,
occasionally over a second from the pi, and pip has a relatively low
timeout when installing stuff. The workaround was to <a href="https://stackoverflow.com/questions/43298872/">tell pip to
calm down, and be patient</a>. I had installed tmux so we could share a
session across the table (for pair programming), and the apt man-db
triggers <a href="https://askubuntu.com/a/1064366/436920">took around 5-15 minutes</a>; with the crunch time we had, this
felt unacceptable. The other technical issue we had was the fact the
raspbian image starts up a lot of unnecessary services by default
which eat into the rasperry pi zero w&rsquo;s very limited memory. This
caused pip to crash due to failure to allocate memory. We had to
disable lightdm (GUI) and the default vision kit demo. Had this been
a device I&rsquo;d use for more than a couple hours, I&rsquo;d go through and
disable things like GIO services, and other bloat that we never
would use.<sup><a id="fnr.3" class="footref" href="#fn.3">3</a></sup>
</p>

<p>
Meanwhile our other two group members worked on a proof of concept
game. The idea the device comes up with a common word, and the user
carries the device around, showing it various text on the wall or on
paper. Using a cloud <a href="https://en.wikipedia.org/wiki/Optical_character_recognition">OCR</a> service, it can recognize the
words seen by the camera. It then will buzz happily when it is shown
the correct word, or buzz sadly if shown the wrong word. Then the
process repeats. It&rsquo;s an &ldquo;iSpy&rdquo; with computer vision and words — a
word hunt!
</p>
</div>
</div>

<div id="outline-container-orgdc5d17e" class="outline-2">
<h2 id="orgdc5d17e">Completion</h2>
<div class="outline-text-2" id="text-orgdc5d17e">
<p>
While our PoC was not deployed in time for presentations, we were
about five to ten minutes away from setting it up, and demoing
it. During the presentations, we found that many of the other groups
experienced the same issues with the Google AIY Vision Kit — due to
the Raspberry Pi platform, Raspbian, and the way one pairs it to
wifi. At least one other group managed to get some non-default code
running on their Pi. We were only given around 3-4 hours from start
to finish, with a time loss factor due to slow internet speeds to
download the initial SD card image, man-db triggers rendering the
device unusable for awhile, and dealing with the lack of suitable
networking configuration.
</p>

<p>
Given all these challenges, I think we did very well. As did every
other group that participated. We did have competition for 1st
place, because some of the other groups had PoC&rsquo;s (though some did
not get the Pi completely working) and others did get the Pi working
but did not have a PoC. We were selected as 1st place, and each was
given either a <a href="https://store.google.com/product/google_home_mini">Google Home Mini</a> or a Google Cloud hoodie. I went
with the hoodie because I don&rsquo;t want to use Google&rsquo;s <a href="https://support.google.com/googlenest/answer/7072285?hl=en">creepy</a> <a href="https://www.youtube.com/watch?v=AAP4N3KyLmM">spyware</a>
voice assistant. And the modding/reverse engineering community has
done very little with this product; nobody has loaded custom
firmware on it, for example.
</p>
</div>
</div>

<div id="outline-container-org88c7429" class="outline-2">
<h2 id="org88c7429">Conclusion</h2>
<div class="outline-text-2" id="text-org88c7429">
<p>
Our issue in seeking out a usable networking topology had be thinking:
if I simply had a device with two wifi radios, I could run one as an
Acesss Point and the other connected to Public WiFi. This device would
then yield this topology, which would be ideal for these sorts of
impromptu projects and activities:
</p>


<figure>
<img src="static/dual-wifi.png" alt="dual-wifi.png">

</figure>

<p>
In addition, it would be perfect for demonstrations of man in the
middle attacks on public wifi, or experimenting with multipath tcp and
wifi.
</p>

<p>
With these sorts of events that start early on a Saturday morning,
it&rsquo;s been useful to agree with a friend to attend the same event. That
way both parties are more likely to show up, because it wouldn&rsquo;t be
very personable to cancel last minute. We also had a wonderful team. I
later met up with most of the same team for another event (post
incoming). Hackathons are a great way to meet new people. I enjoyed
this event thoroughly.
</p>

<p>
See you at the next hackathon :)
</p>
</div>
</div>
<div id="footnotes">
<h2 class="footnotes">Footnotes: </h2>
<div id="text-footnotes">

<div class="footdef"><sup><a id="fn.1" class="footnum" href="#fnr.1">1</a></sup> <div class="footpara"><p class="footpara">
There isn&rsquo;t a link online yet :(. I will update this note when
I find <b>a link</b> to the event.
</p></div></div>

<div class="footdef"><sup><a id="fn.2" class="footnum" href="#fnr.2">2</a></sup> <div class="footpara"><p class="footpara">
Full list of materials <a href="https://aiyprojects.withgoogle.com/vision#list-of-materials">here</a>.
</p></div></div>

<div class="footdef"><sup><a id="fn.3" class="footnum" href="#fnr.3">3</a></sup> <div class="footpara"><p class="footpara">
Stay tuned as I explore why I find distros like Debian not
ideal in practice in a future post ☺
</p></div></div>


</div>
</div><div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-community.html">community</a> <a href="tag-networking.html">networking</a> </div>
<div class="post-date">06 Nov 2019</div><h1 class="post-title"><a href="2019-11-06-gdg-milwaukee-2019-devfest---we-participated.html">GDG Milwaukee 2019 DevFest - We participated!</a></h1>
<p>
I attended the <a href="https://www.meetup.com/GDG-UWM/events/264945191/">GDG Milwaukee 2019 DevFest</a> last Saturday. This was my
second hackathon. Around 6-9 teams participated. We coded for six
hours, and I learned a lot about team dynamics. We formed a team of eight
participants. We encountered a couple significant challenges.
</p>

<div id="outline-container-org37aa5bb" class="outline-2">
<h2 id="org37aa5bb">The stack matters</h2>
<div class="outline-text-2" id="text-org37aa5bb">
<p>
Initially we decided to use Python and the <a href="https://www.djangoproject.com/">Django framework</a>. This
turned out to be a grave error, because picking up Django quickly
while staying productive is challenging. This challenge is
multiplied by unfamiliarity with <a href="https://en.wikipedia.org/wiki/Model%E2%80%93view%E2%80%93controller">MVC</a>/<a href="https://en.wikipedia.org/wiki/Model%E2%80%93view%E2%80%93presenter">MVP</a> web frameworks.
</p>

<p>
A couple hours in we sat down and decided Django had to go. We
realized two of us had prior experience with <a href="https://palletsprojects.com/p/flask/">Flask</a>. Combined with
<a href="https://www.flaskapi.org/">flaskapi</a> this could be a wonderfully simple way to build a RESTful
API backend.
</p>

<p>
For the frontend we used <a href="https://create-react-app.dev/">Create React App</a>. I did not work with it
much, but I found it easy to run, deploy, and tweak. I think it was
a solid choice.
</p>

<p>
The hardest part of our stack was integrating our hand-rolled RESTful
API into the React.js based frontend. In fact we weren't able to
complete this, but we got really close. It was a lot of work to get
as far as we did as a team.
</p>

<p>
Most of the other groups also used Python. Multiple groups used
Django, and one group even used <a href="https://www.django-rest-framework.org/">Django Rest Framework</a>. They
appeared to be facing the same challenge we were having with getting
Django to do anything productive in the allotted time. I know at my
next hackathon I won't be recommending Django to the uninitiated.
</p>

<p>
The winning team used <a href="https://firebase.google.com/">Firebase</a>. Every project I've seen done in
Firebase was rapidly prototyped, indicating it is extremely suitable
for hackathons. I have <a href="https://www.gnu.org/philosophy/who-does-that-server-really-serve.html">deep reservations</a> about using a proprietary
PaaS, but maybe I can put this concern aside for my next
hackathon. :)
</p>

<p>
Java. At my university and most others in my area, Java is the first
language we learn. In some cases it may be the only language one
really learns well. In this light, a team member mentioned perhaps we
could use <a href="https://tomcat.apache.org/">Tomcat</a> or some other Java web framework in future. This
seems like a superb idea, I hope to explore this in an upcoming
project with classmates.
</p>
</div>
</div>

<div id="outline-container-orgc4895ff" class="outline-2">
<h2 id="orgc4895ff">Debian surprised me (again)</h2>
<div class="outline-text-2" id="text-orgc4895ff">
<p>
A funny experience during the hackathon was discovering a rather
surprising patch Debian's virtualenv package ships. On CentOS 7,
Gentoo, and possibly anything not Debian derived, running <code>python3 -m
  virtualenv ./venv</code> will create a Python3 virtual environment. <a href="https://stackoverflow.com/questions/51534831/python3-virtualenv-installs-python2">This is
not the case on Debian</a>. Instead Debian <a href="https://salsa.debian.org/python-team/modules/python-virtualenv/blob/master/debian/patches/python2-default.patch">will always default to
installing <code>python2</code></a> in the virtual environment. One must pass <code>-p
  python3</code> to install python3. Sure seems wonky to me!
</p>
</div>
</div>


<div id="outline-container-org887d2af" class="outline-2">
<h2 id="org887d2af">Demos never work</h2>
<div class="outline-text-2" id="text-org887d2af">
<p>
We almost had a working demo, but the part that got us was
deployment. I spun up a <a href="https://www.vultr.com/">Vultr</a> VPS, installed npm, node, caddy,
virtualenv. I got the API backend running, and built the Create
React App pages, and tied it all together with a Caddyfile, but it
simply wouldn't work. There was too many moving parts, and manual
deployment was too tedious to get right within the time frame.
</p>

<p>
There is something to be said for working in
containerized workflows; this would have been a non-issue. Drop in a
<code>docker-compose.yml</code> into the project and just run <code>docker-compose
  up</code>. Next time :)
</p>
</div>
</div>

<div id="outline-container-orgdbf93a7" class="outline-2">
<h2 id="orgdbf93a7">Teamwork is essential</h2>
<div class="outline-text-2" id="text-orgdbf93a7">
<p>
We had a team of eight members, and it was challenging to find
tasks for everybody. Given we had two major components &#x2014; frontend
and backend &#x2014; and we had quite a few members who needed
instruction to get started, it was challenging to give both the
coding and instructing enough attention. In future I strive to have
more balanced teams so everybody can feel more involved. Perhaps a
good rule of thumb is to pair at most one beginner to one
intermediate, never more than one.
</p>

<p>
Something else I think that will help is ensure nobody gets
pigeonholed into managing the project; rather, share the
responsibility. Project managers are likely not effective in a
half-day Hackathon.
</p>

<p>
Keep morale up. Don't let negativity distract from the team
tasks. Redirect negativity into going for a walk, playing video
games, or simply taking a break. Make sure to smile.
</p>
</div>
</div>

<div id="outline-container-org021700c" class="outline-2">
<h2 id="org021700c">Conclusion</h2>
<div class="outline-text-2" id="text-org021700c">
<p>
I had fun at GDG Milwaukee DevFest. Good food, good company. We
found our initial choice of Django was not productive in true
hackathon spirit. Flask was better for this. Maybe next time we'll
consider Firebase. If I had a nickle for every Debian patch that
violated my own idea of least surprise, I'd have laundry
money. Demos are hard, deployments should be automated or otherwise
streamlined. Finally, teamwork is vital. Keep the team small, and
make sure everybody has things to do.
</p>

<p>
See you next year GDG.
</p>
</div>
</div>
<div class="taglist"><a href="tags.html">Tags</a>: <a href="tag-community.html">community</a> </div><div id="archive">
<a href="archive.html">Other posts</a>
</div>
</div>
<div id="postamble" class="status">
<hr/>
<ul class="inline-list interpunct">
<li>Powered by <a href="https://github.com/bastibe/org-static-blog">org-static-blog</a></li>
<li>Like what I do? <a href="https://www.buymeacoffee.com/winny">Buy me a Coffee</a></li>
</ul>
<p>© Winston Weinert (winny) — <a href="https://creativecommons.org/licenses/by-sa/4.0/legalcode">CC-BY-SA-4.0</a></p>
</div>
</body>
</html>
